stages:
  - lint
  - test
  - jq
  - publish
  - release

include:
  - .node-job.yml

version:
  stage: .pre
  image:
    name: itisfoundation/jq:v0
    entrypoint: [""]
  script:
    - APP_VERSION=$(jq -r '.version' package.json)
    - echo APP_VERSION=$APP_VERSION | tee version.env
  artifacts:
    reports:
      dotenv: version.env

lint-job:
  stage: lint
  extends: .node-job
  variables:
    NPM_SCRIPT: lint-report
  artifacts:
    paths:
      - lint-report.json

unit-test-job:
  stage: test
  extends: .node-job
  variables:
    NPM_SCRIPT: test
  artifacts:
    reports:
      junit: test-results.xml
    when: always
  dependencies: []

jq:
  stage: jq
  image:
    name: itisfoundation/jq:v0
    entrypoint: [""]
  before_script: []
  script:
    - cat lint-report.json | jq
  needs:
    - lint-job

publish:
  stage: publish
  extends: .node-job
  script:
    - echo "@uness:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/" > .npmrc
    - echo "//${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
    - npm publish
  dependencies: []
  needs:
    - lint-job
    - unit-test-job
  rules:
    - if: '$CI_COMMIT_TAG'

release:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  release:
    name: $APP_VERSION
    tag_name: $APP_VERSION
    description: Release $APP_VERSION
  script:
    - echo "Creating release $APP_VERSION"
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: manual
  needs: ["version"]
